﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace GridMvcApp.Controllers
{
    [HandleError]
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewData["Message"] = "欢迎使用 ASP.NET MVC!";

            return View();
        }

        public ActionResult About()
        {
            return View();
        }

        public ActionResult GridViewPage1()
        {
            return View();
        }
        public ActionResult GridViewPage2()
        {
            return View();
        }

        class Node
        {
            public int id { get; set; }
            public string name { get; set; }
            public DateTime time { get; set; }
        }

        public ActionResult GetData()
        {
            IList<Node> list = new List<Node>();
            var total = 100;
            for (var i = 0; i < total; i++)
            {
                list.Add(new Node()
                {
                    id = i,
                    name = "部门" + i,
                    time = DateTime.Now
                });
            }
            var gridData = new
            {
                Rows = list,
                Total = total
            };
            return Json(gridData);
        }



        public ActionResult GetData2()
        {
            //排序的字段名
            string sortname = Request.Params["sortname"];
            //排序的方向
            string sortorder = Request.Params["sortorder"];
            //当前页
            int page = Convert.ToInt32(Request.Params["page"]);
            //每页显示的记录数
            int pagesize = Convert.ToInt32(Request.Params["pagesize"]);

            IList<Node> list = new List<Node>();
            var total = 1000;
            for (var i = 0; i < total; i++)
            {
                list.Add(new Node()
                {
                    id = i,
                    name = "部门" + i,
                    time = DateTime.Now
                });
            }
            //这里模拟排序操作
            if (sortorder == "desc")
                list = list.OrderByDescending(c => c.id).ToList();
            else
                list = list.OrderBy(c => c.id).ToList();

            IList<Node> targetList = new List<Node>();
            //这里模拟分页操作
            for (var i = 0; i < total; i++)
            {
                if (i >= (page - 1) * pagesize && i < page * pagesize)
                {
                    targetList.Add(list[i]);
                }
            }
            var griddata = new { Rows = targetList, Total = total };
            return Json(griddata);
        }
    }
}
